module HaXmlImpl (haXmlImpl) where

import Control.Parallel.Strategies
import Text.XML.HaXml
import Impl


instance NFData Document where
    rnf (Document _ _ root _) = rnf root

instance NFData Element where
    rnf (Elem name attrs content) = rnf (name, attrs, content)

instance NFData AttValue where
    rnf (AttValue val) = rnf val

instance NFData Reference where
    rnf ref = ()

instance NFData Content where
    rnf content = ()

haXmlImpl :: Impl
haXmlImpl = Impl {
        libname = "HaXml",
        parseFunc = \(InputText _ _ xml) ->
            rnf (xmlParse "input" xml) `seq` return ()
    }

