module HexpatImpl (hexpatImpls) where

import Control.Parallel.Strategies
import Text.XML.Expat.Tree
import Text.XML.Expat.Format
import Text.XML.Expat.Qualified
import Text.XML.Expat.IO
import qualified Data.Text as T
import Impl


fromRight :: Either XMLParseError a -> a
fromRight x = case x of
    Right right -> right
    Left err -> error (show err)

hexpatImpls :: [Impl]
hexpatImpls = [
        Impl {
            libname = "hexpat-lazy-string",
            parseFunc = \(InputText _ xml _) ->
                rnf (fst $ parseTree Nothing xml :: UNode String) `seq` return ()
        },
        Impl {
            libname = "hexpat-lazy-text",
            parseFunc = \(InputText _ xml _) -> 
                rnf (fst $ parseTree Nothing xml :: UNode T.Text) `seq` return ()
        },
        Impl {
            libname = "hexpat-strict-string",
            parseFunc = \(InputText xml _ _) ->
                rnf (fromRight $ parseTree' Nothing xml :: UNode String) `seq` return ()
        },
        Impl {
            libname = "hexpat-strict-text",
            parseFunc = \(InputText xml _ _) ->
                rnf (fromRight $ parseTree' Nothing xml :: UNode T.Text) `seq` return ()
        }
    ]

