module Impl where

import Control.Parallel.Strategies
import qualified Data.ByteString as B
import qualified Data.ByteString.Lazy as L
import qualified Data.Text as T

data InputText = InputText {
        textBS   :: B.ByteString,
        textLBS  :: L.ByteString,
        textS    :: String
    }

instance NFData B.ByteString where
    rnf bs = ()

instance NFData L.ByteString where
    rnf = rnf . L.toChunks

instance NFData T.Text where
    rnf bs = ()

instance NFData InputText where
    rnf (InputText bs lbs s) = rnf (bs, lbs, s)

data Impl = Impl {
        libname   :: String,
        parseFunc :: InputText -> IO ()
    }

