module LightImpl (lightImpl) where

import Control.Parallel.Strategies
import Text.XML.Light.Input
import Text.XML.Light.Types
import Impl


instance NFData Content where
    rnf (Elem elt)   = rnf elt
    rnf (Text cdata) = rnf cdata
    rnf (CRef str)   = rnf str

instance NFData Element where
    rnf (Element na at co li) = rnf (na,at,co,li)

instance NFData CData where
    rnf (CData ve da li) = rnf (ve,da,li)

instance NFData QName where
    rnf (QName na ur pr) = rnf (na,ur,pr)

instance NFData Attr where
    rnf (Attr ke va) = rnf (ke, va)

instance NFData CDataKind where
    rnf (CDataText) = ()
    rnf (CDataVerbatim) = ()
    rnf (CDataRaw) = ()

lightImpl :: Impl
lightImpl = Impl {
        libname = "xml-light",
        parseFunc = \(InputText _ _ xml) ->
            rnf (parseXML xml) `seq` return ()
    }

