import Data.Time.Calendar 
import Data.Time.LocalTime
import Graphics.Rendering.Chart
import Data.Accessor
--import Data.Accessor.Tuple
import System.Random
import Graphics.Rendering.Chart.Gtk
import Control.Applicative
import Control.Arrow

chart :: String -> [String] -> [(Int, [Int])] -> Renderable ()
chart title parsers speeds = toRenderable layout
  where
    plotData :: Int -> [(Int,Int)]
    plotData i = map (second (!! i)) speeds

    layout = layout1_title ^= title
               $ layout1_bottom_axis ^: laxis_title ^= "document size (k bytes)"
               $ layout1_left_axis ^: laxis_title ^= "time (milliseconds)"
               $ layout1_plots ^= map (\(parser, idx, line) -> 
                      Left $ toPlot $ plot parser line (plotData idx)
                     ) (zip3 parsers [0..] [hax, light, hexs, hext, hexs, hext])
               $ defaultLayout1

    plot :: String -> CairoLineStyle -> [(Int, Int)] -> PlotLines Double Double
    plot title style pts = plot_lines_style ^= style
                 $ plot_lines_values ^= [map (((/1024) . fromIntegral) *** ((/1000) . fromIntegral)) pts]
                 $ plot_lines_title ^= title
                 $ defaultPlotLines

    hax = solidLine lineWidth green
    light = solidLine lineWidth blue
    hext = solidLine lineWidth red
    hexs = solidLine lineWidth orange
    orange = color 255 192 0

    lineWidth = 1.0

main = do
    (title:parsers_:speeds_) <- lines <$> getContents
    let parsers = read parsers_ :: [String]
        speeds  = map read speeds_ :: [(Int, [Int])]
        c = chart title parsers speeds
    renderableToWindow c 720 480
    renderableToPNGFile c 720 480 "test.png"
