import System.IO
import Control.Applicative
import Control.Arrow
import System.Posix.Files
import Control.Monad
import qualified Data.IntMap as IM
import Data.IntMap (IntMap)
import System.Random
import Data.Maybe
import Data.List
import System.Exit
import System.Process


bucketize :: [(String, Int)] -> IntMap [(String, Int)]
bucketize = foldl' add IM.empty
  where
    add :: IntMap [(String, Int)] -> (String, Int) -> IntMap [(String, Int)]
    add im pair@(file, size) =
        let bucket = size `div` 1000
        in  if bucket <= 0 || bucket >= 100
            then im
            else IM.alter (Just . (pair:) . fromMaybe []) bucket im

main = do
    files <- lines <$> getContents
    withSize <- forM files $ \file -> do
        fs <- getFileStatus file
        return (file, fileSize fs)
    let buckets = bucketize $ map (second fromIntegral) withSize
    outFiles <- catMaybes <$> forM (IM.toList buckets) (\(idx, files) -> do
            if null files
                then return Nothing
                else do
                    let len = length files
                    idx <- randomRIO (0,len-1)
                    return $ Just $ files !! idx
        )
    forM_ outFiles $ \(file, size) -> do
        putStrLn $ show size ++ " " ++ file
        h <- runProcess "/bin/cp" [file, "files/"] Nothing Nothing Nothing Nothing Nothing
        ret <- waitForProcess h
        unless (ret == ExitSuccess) $ do
            error "ERROR! copy failed!"

